2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by many projects via the gnulib maintainer-makefile module.
5 ## Copyright (C) 2001-2009 Free Software Foundation, Inc.
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 ## GNU General Public License for more details.
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program. If not, see <http://www.gnu.org/licenses/>.
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
24 # Override this in cfg.mk if you use a non-standard build-aux directory.
25 build_aux ?
= $(srcdir)/build-aux
27 # Do not save the original name or timestamp in the .tar.gz file.
28 # Use --rsyncable if available.
30 $(shell gzip
--help
2>/dev
/null|grep rsyncable
>/dev
/null
&& echo
--rsyncable
)
31 GZIP_ENV
= '--no-name --best $(gzip_rsyncable)'
33 # cfg.mk must define the gpg_key_ID used by this package.
36 VC-tag
= git tag
-s
-m
'$(VERSION)' -u
'$(gpg_key_ID)'
38 VC_LIST
= $(build_aux
)/vc-list-files
-C
$(srcdir)
41 $(VC_LIST
) | if
test -f
$(srcdir)/.x-
$@
; then grep
-vEf
$(srcdir)/.x-
$@
; \
42 else grep
-Ev
"$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi
44 ifeq ($(origin prev_version_file
), undefined
)
45 prev_version_file
= $(srcdir)/.prev-version
48 PREV_VERSION
:= $(shell cat
$(prev_version_file
) 2>/dev
/null
)
49 VERSION_REGEXP
= $(subst .
,\.
,$(VERSION
))
50 PREV_VERSION_REGEXP
= $(subst .
,\.
,$(PREV_VERSION
))
53 this-vc-tag
= v
$(VERSION
)
54 this-vc-tag-regexp
= v
$(VERSION_REGEXP
)
56 tag-package
= $(shell echo
"$(PACKAGE)" | tr
'[:lower:]' '[:upper:]')
57 tag-this-version
= $(subst .
,_
,$(VERSION
))
58 this-vc-tag
= $(tag-package
)-$(tag-this-version
)
59 this-vc-tag-regexp
= $(this-vc-tag
)
61 my_distdir
= $(PACKAGE
)-$(VERSION
)
63 # Old releases are stored here.
64 release_archive_dir ?
= ..
/release
66 # Prevent programs like 'sort' from considering distinct strings to be equal.
67 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
74 _cfg_mk
:= $(shell test -f
$(srcdir)/cfg.mk
&& echo
'$(srcdir)/cfg.mk')
76 # Collect the names of rules starting with `sc_'.
77 syntax-check-rules
:= $(sort $(shell sed
-n
's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
78 $(srcdir)/$(ME
) $(_cfg_mk
)))
79 .PHONY
: $(syntax-check-rules
)
81 local-checks-available
= \
83 .PHONY
: $(local-checks-available
)
85 # Arrange to print the name of each syntax-checking rule just before running it.
86 $(syntax-check-rules
): %: %.m
87 $(patsubst %, %.m
, $(syntax-check-rules
)):
88 @echo
$(patsubst sc_
%.m
, %, $@
)
90 local-check
:= $(filter-out $(local-checks-to-skip
), $(local-checks-available
))
92 syntax-check
: $(local-check
)
93 # @grep -nE '# *include <(limits|std(def|arg|bool))\.h>' \
94 # $$(find -type f -name '*.[chly]') && \
95 # { echo '$(ME): found conditional include' 1>&2; \
98 # grep -nE '^# *include <(string|stdlib)\.h>' \
99 # $(srcdir)/{lib,src}/*.[chy] && \
100 # { echo '$(ME): FIXME' 1>&2; \
102 # FIXME: don't allow `#include .strings\.h' anywhere
104 # By default, _prohibit_regexp does not ignore case.
106 _ignore_case
= $$(test -n
"$$ignore_case" && echo
-i ||
:)
108 # There are many rules below that prohibit constructs in this package.
109 # If the offending construct can be matched with a grep-E-style regexp,
110 # use this macro. The shell variables "re" and "msg" must be defined.
111 define _prohibit_regexp
112 dummy
=; : so we do not need a semicolon before each use
; \
113 test "x$$re" != x ||
{ echo
'$(ME): re not defined' 1>&2; exit
1; }; \
114 test "x$$msg" != x ||
{ echo
'$(ME): msg not defined' 1>&2; exit
1; };\
115 grep
$(_ignore_case
) -nE
"$$re" $$($(VC_LIST_EXCEPT
)) && \
116 { echo
'$(ME): '"$$msg" 1>&2; exit
1; } ||
:
119 sc_avoid_if_before_free
:
120 @
$(build_aux
)/useless-if-before-free \
121 $(useless_free_options
) \
122 $$($(VC_LIST_EXCEPT
) | grep
-v useless-if-before-free
) && \
123 { echo
'$(ME): found useless "if" before "free" above' 1>&2; \
126 sc_cast_of_argument_to_free
:
127 @re
='\<free *\( *\(' msg
='don'\''t cast free argument' \
130 sc_cast_of_x_alloc_return_value
:
131 @re
='\*\) *x(m|c|re)alloc\>' \
132 msg
='don'\''t cast x*alloc return value' \
135 sc_cast_of_alloca_return_value
:
136 @re
='\*\) *alloca\>' msg
='don'\''t cast alloca return value' \
140 @re
='[ ] ' msg
='found SPACE-TAB sequence; remove the SPACE' \
143 # Don't use *scanf or the old ato* functions in `real' code.
144 # They provide no error checking mechanism.
145 # Instead, use strto* functions.
146 sc_prohibit_atoi_atof
:
147 @re
='\<([fs]?scanf|ato([filq]|ll)) *\(' \
148 msg
='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q' \
151 # Use STREQ rather than comparing strcmp == 0, or != 0.
153 @grep
-nE
'! *str''cmp *\(|\<str''cmp *\([^)]+\) *==' \
154 $$($(VC_LIST_EXCEPT
)) \
155 | grep
-vE
':# *define STREQ\(' && \
156 { echo
'$(ME): use STREQ in place of the above uses of str''cmp' \
159 # Pass EXIT_*, not number, to usage, exit, and error (when exiting)
160 sc_prohibit_magic_number_exit
:
161 @re
='\<(usage|exit) ?\([0-9]|\<error ?\([1-9][0-9]*,' \
162 msg
='use EXIT_* values rather than magic number' \
165 # Using EXIT_SUCCESS as the first argument to error is misleading,
166 # since when that parameter is 0, error does not exit. Use `0' instead.
167 sc_error_exit_success
:
168 @grep
-nE
'error \(EXIT_SUCCESS,' \
169 $$($(VC_LIST_EXCEPT
) | grep
-E
'\.[chly]$$') && \
170 { echo
'$(ME): found error (EXIT_SUCCESS' 1>&2; exit
1; } ||
:
172 # `FATAL:' should be fully upper-cased in error messages
173 # `WARNING:' should be fully upper-cased, or fully lower-cased
174 sc_error_message_warn_fatal
:
175 @grep
-nEA2
'[^rp]error \(' $$($(VC_LIST_EXCEPT
)) \
176 | grep
-E
'"Warning|"Fatal|"fatal' && \
177 { echo
'$(ME): use FATAL, WARNING or warning' 1>&2; \
180 # Error messages should not start with a capital letter
181 sc_error_message_uppercase
:
182 @grep
-nEA2
'[^rp]error \(' $$($(VC_LIST_EXCEPT
)) \
184 | grep
-vE
'"FATAL|"WARNING|"Java|"C#|PRIuMAX' && \
185 { echo
'$(ME): found capitalized error message' 1>&2; \
188 # Error messages should not end with a period
189 sc_error_message_period
:
190 @grep
-nEA2
'[^rp]error \(' $$($(VC_LIST_EXCEPT
)) \
191 | grep
-E
'[^."]\."' && \
192 { echo
'$(ME): found error message ending in period' 1>&2; \
196 @re
=file
''system ignore_case
=1 \
197 msg
='found use of "file''system"; spell it "file system"' \
200 # Don't use cpp tests of this symbol. All code assumes config.h is included.
201 sc_prohibit_have_config_h
:
202 @grep
-n
'^# *if.*HAVE''_CONFIG_H' $$($(VC_LIST_EXCEPT
)) && \
203 { echo
'$(ME): found use of HAVE''_CONFIG_H; remove' \
206 # Nearly all .c files must include <config.h>. However, we also permit this
207 # via inclusion of a package-specific header, if cfg.mk specified one.
208 # config_h_header must be suitable for grep -E.
209 config_h_header ?
= <config\.h
>
211 @if
$(VC_LIST_EXCEPT
) | grep
-l
'\.c$$' > /dev
/null
; then \
212 grep
-EL
'^# *include $(config_h_header)' \
213 $$($(VC_LIST_EXCEPT
) | grep
'\.c$$') \
215 { echo
'$(ME): the above files do not include <config.h>' \
216 1>&2; exit
1; } ||
:; \
220 # You must include <config.h> before including any other header file.
221 # This can possibly be via a package-specific header, if given by cfg.mk.
222 sc_require_config_h_first
:
223 @if
$(VC_LIST_EXCEPT
) | grep
-l
'\.c$$' > /dev
/null
; then \
225 for i in
$$($(VC_LIST_EXCEPT
) | grep
'\.c$$'); do \
226 grep
'^# *include\>' $$i | sed
1q \
227 | grep
-E
'^# *include $(config_h_header)' > /dev
/null \
228 ||
{ echo
$$i; fail
=1; }; \
231 { echo
'$(ME): the above files include some other header' \
232 'before <config.h>' 1>&2; exit
1; } ||
:; \
236 sc_prohibit_HAVE_MBRTOWC
:
237 @re
='\bHAVE_MBRTOWC\b' msg
="do not use $$re; it is always defined" \
240 # To use this "command" macro, you must first define two shell variables:
241 # h: the header, enclosed in <> or ""
242 # re: a regular expression that matches IFF something provided by $h is used.
243 define _header_without_use
244 dummy
=; : so we do not need a semicolon before each use
; \
245 h_esc
=`echo "$$h"|sed 's/\./\\\\./g'`; \
246 if
$(VC_LIST_EXCEPT
) | grep
-l
'\.c$$' > /dev
/null
; then \
247 files
=$$(grep
-l
'^# *include '"$$h_esc" \
248 $$($(VC_LIST_EXCEPT
) | grep
'\.c$$')) && \
249 grep
-LE
"$$re" $$files | grep .
&& \
250 { echo
"$(ME): the above files include $$h but don't use it" \
251 1>&2; exit
1; } ||
:; \
256 # Prohibit the inclusion of assert.h without an actual use of assert.
257 sc_prohibit_assert_without_use
:
258 @h
='<assert.h>' re
='\<assert *\(' $(_header_without_use
)
260 # Prohibit the inclusion of close-stream.h without an actual use.
261 sc_prohibit_close_stream_without_use
:
262 @h
='"close-stream.h"' re
='\<close_stream *\(' $(_header_without_use
)
264 # Prohibit the inclusion of getopt.h without an actual use.
265 sc_prohibit_getopt_without_use
:
266 @h
='<getopt.h>' re
='\<getopt(_long)? *\(' $(_header_without_use
)
268 # Don't include quotearg.h unless you use one of its functions.
269 sc_prohibit_quotearg_without_use
:
270 @h
='"quotearg.h"' re
='\<quotearg(_[^ ]+)? *\(' $(_header_without_use
)
272 # Don't include quote.h unless you use one of its functions.
273 sc_prohibit_quote_without_use
:
274 @h
='"quote.h"' re
='\<quote(_n)? *\(' $(_header_without_use
)
276 # Don't include this header unless you use one of its functions.
277 sc_prohibit_long_options_without_use
:
278 @h
='"long-options.h"' re
='\<parse_long_options *\(' \
279 $(_header_without_use
)
281 # Don't include this header unless you use one of its functions.
282 sc_prohibit_inttostr_without_use
:
283 @h
='"inttostr.h"' re
='\<(off|[iu]max|uint)tostr *\(' \
284 $(_header_without_use
)
286 # Don't include this header unless you use one of its functions.
287 sc_prohibit_error_without_use
:
289 re
='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
290 $(_header_without_use
)
292 sc_prohibit_safe_read_without_use
:
293 @h
='"safe-read.h"' re
='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
294 $(_header_without_use
)
296 sc_prohibit_argmatch_without_use
:
298 re
='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<argmatch(_exit_fn|_(in)?valid) *\()' \
299 $(_header_without_use
)
301 sc_prohibit_canonicalize_without_use
:
302 @h
='"canonicalize.h"' \
303 re
='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode)' \
304 $(_header_without_use
)
306 sc_prohibit_root_dev_ino_without_use
:
307 @h
='"root-dev-ino.h"' \
308 re
='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
309 $(_header_without_use
)
311 sc_prohibit_openat_without_use
:
313 re
='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \
314 $(_header_without_use
)
316 # Prohibit the inclusion of c-ctype.h without an actual use.
317 ctype_re
= isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
318 |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
319 sc_prohibit_c_ctype_without_use
:
320 @h
='[<"]c-ctype.h[">]' re
='\<c_($(ctype_re)) *\(' $(_header_without_use
)
323 _sp
= $(_empty
) $(_empty
)
324 # The following list was generated by running:
325 # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
326 # | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
328 bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
329 sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
330 siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
331 sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
332 _sig_function_re
= $(subst $(_sp
),|
,$(strip $(_sig_functions
)))
333 # The following were extracted from "man signal.h" manually.
334 _sig_types_and_consts
= \
335 MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK \
336 SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL \
337 SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE \
338 SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t \
339 sigstack sigval stack_t ucontext_t
340 # generated via this:
341 # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
343 SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT \
344 SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL \
345 SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP \
346 SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR \
347 SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS \
348 SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1 \
349 SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW \
351 _sig_syms_re
= $(subst $(_sp
),|
,$(strip $(_sig_names
) $(_sig_types_and_consts
)))
353 # Prohibit the inclusion of signal.h without an actual use.
354 sc_prohibit_signal_without_use
:
356 re
='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>' \
357 $(_header_without_use
)
360 @re
='\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \
361 msg
='do not use HAVE''_FCNTL_H or O'_NDELAY \
364 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
366 # Each nonempty ChangeLog line must start with a year number, or a TAB.
368 @if
$(VC_LIST_EXCEPT
) | grep
-l
'^ChangeLog$$' >/dev
/null
; then \
370 $$($(VC_LIST_EXCEPT
) | grep
'^ChangeLog$$') && \
371 { echo
'$(ME): found unexpected prefix in a ChangeLog' 1>&2; \
375 # Ensure that each .c file containing a "main" function also
376 # calls set_program_name.
378 @if
$(VC_LIST_EXCEPT
) | grep
-l
'\.c$$' > /dev
/null
; then \
379 files
=$$(grep
-l
'^main *(' $$($(VC_LIST_EXCEPT
) | grep
'\.c$$')); \
380 grep
-LE
'set_program_name *\(m?argv\[0\]\);' $$files \
382 { echo
'$(ME): the above files do not call set_program_name' \
383 1>&2; exit
1; } ||
:; \
387 # Require that the final line of each test-lib.sh-using test be this one:
389 # Note: this test requires GNU grep's --label= option.
390 Exit_witness_file ?
= tests
/test-lib.sh
391 Exit_base
:= $(notdir $(Exit_witness_file
))
392 sc_require_test_exit_idiom
:
393 @if
test -f
$(srcdir)/$(Exit_witness_file
); then \
395 for i in
$$(grep
-l
-F
'srcdir/$(Exit_base)' \
396 $$($(VC_LIST
) tests
)); do \
397 tail
-n1
$$i | grep
'^Exit .' > /dev
/null \
398 && : ||
{ die
=1; echo
$$i; } \
401 { echo
1>&2 '$(ME): the final line in each of the above is not:'; \
402 echo
1>&2 'Exit something'; \
407 @re
='\<the ''the\>' \
408 ignore_case
=1 msg
='found use of "the ''the";' \
413 msg
='found trailing blank(s)' \
416 # Match lines like the following, but where there is only one space
417 # between the options and the description:
418 # -D, --all-repeated[=delimit-method] print all duplicate lines\n
419 longopt_re
= --[a-z
][0-9A-Za-z-
]*(\
[?
=[0-9A-Za-z-
]*\
]?
)?
420 sc_two_space_separator_in_usage
:
421 @grep
-nE
'^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \
422 $$($(VC_LIST_EXCEPT
)) && \
423 { echo
"$(ME): help2man requires at least two spaces between"; \
424 echo
"$(ME): an option and its description"; \
427 # Look for diagnostics that aren't marked for translation.
428 # This won't find any for which error's format string is on a separate line.
429 sc_unmarked_diagnostics
:
431 '\<error \([^"]*"[^"]*[a-z]{3}' $$($(VC_LIST_EXCEPT
)) \
432 | grep
-v
'_''(' && \
433 { echo
'$(ME): found unmarked diagnostic(s)' 1>&2; \
436 # Avoid useless parentheses like those in this example:
437 # #if defined (SYMBOL) || defined (SYM2)
438 sc_useless_cpp_parens
:
439 @grep
-n
'^# *if .*defined *(' $$($(VC_LIST_EXCEPT
)) && \
440 { echo
'$(ME): found useless parentheses in cpp directive' \
443 # Require the latest GPL.
445 @re
='either ''version [^3]' msg
='GPL vN, N!=3' \
449 Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
451 sc_prohibit_cvs_keyword
:
452 @re
='\$$($(cvs_keywords))\$$' \
453 msg
='do not use CVS keyword expansion' \
456 # Make sure we don't use st_blocks. Use ST_NBLOCKS instead.
457 # This is a bit of a kludge, since it prevents use of the string
458 # even in comments, but for now it does the job with no false positives.
459 sc_prohibit_stat_st_blocks
:
460 @re
='[.>]st_blocks' msg
='do not use st_blocks; use ST_NBLOCKS' \
463 # Make sure we don't define any S_IS* macros in src/*.c files.
464 # They're already defined via gnulib's sys/stat.h replacement.
465 sc_prohibit_S_IS_definition
:
466 @re
='^ *# *define *S_IS' \
467 msg
='do not define S_IS* macros; include <sys/stat.h>' \
470 # Each program that uses proper_name_utf8 must link with
471 # one of the ICONV libraries.
472 sc_proper_name_utf8_requires_ICONV
:
473 @progs
=$$(grep
-l
'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT
)));\
474 if
test "x$$progs" != x
; then \
476 for p in
$$progs; do \
477 dir=$$(dirname
"$$p"); \
478 base
=$$(basename "$$p" .c
); \
479 grep
"$${base}_LDADD.*ICONV)" $$dir/Makefile.am
> /dev
/null \
480 ||
{ fail
=1; echo
1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
483 { echo
1>&2 '$(ME): the above do not link with any ICONV library'; \
487 # Warn about "c0nst struct Foo const foo[]",
488 # but not about "char const *const foo" or "#define const const".
490 @re
='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b' \
491 msg
='redundant "const" in declarations' \
494 sc_const_long_option
:
495 @grep
'^ *static.*struct option ' $$($(VC_LIST_EXCEPT
)) \
496 | grep
-Ev
'const struct option|struct option const' && { \
497 echo
1>&2 '$(ME): add "const" to the above declarations'; \
501 $$(sed
-n
'/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
503 | grep
-v
'^Copyright .*Free Software' \
507 # Ensure that we don't accidentally insert an entry into an old NEWS block.
509 @if
test -f
$(srcdir)/NEWS
; then \
510 test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : || \
511 { echo
'$(ME): you have modified old NEWS' 1>&2; exit
1; }; \
514 # Update the hash stored above. Do this after each release and
515 # for any corrections to old entries.
516 update-NEWS-hash
: NEWS
517 perl
-pi
-e
's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
520 # Ensure that we use only the standard $(VAR) notation,
521 # not @...@ in Makefile.am, now that we can rely on automake
522 # to emit a definition for each substituted variable.
523 # We use perl rather than "grep -nE ..." to exempt a single
524 # use of an @...@-delimited variable name in src/Makefile.am.
526 @perl
-ne
'/\@[A-Z_0-9]+\@/ && !/^cu_install_program =/' \
527 -e
'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}' \
528 $$($(VC_LIST_EXCEPT
) | grep
-E
'(^|/)Makefile\.am$$') \
529 && { echo
'$(ME): use $$(...), not @...@' 1>&2; exit
1; } ||
:
531 news-date-check
: NEWS
532 today
=`date +%Y-%m-%d`; \
533 if head
$(srcdir)/NEWS | grep
'^\*.* $(VERSION_REGEXP) ('$$today')' \
537 echo
"version or today's date is not in NEWS" 1>&2; \
541 sc_makefile_TAB_only_indentation
:
542 @grep
-nE
'^ [ ]{8}' \
543 $$($(VC_LIST_EXCEPT
) | grep
-E
'akefile|\.mk$$') \
544 && { echo
'$(ME): found TAB-8-space indentation' 1>&2; \
548 @grep
-nE
'(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]' \
549 $$($(VC_LIST_EXCEPT
) | grep
-E
'(^configure\.ac|\.m4)$$') \
550 && { echo
'$(ME): quote the first arg to AC_DEF*' 1>&2; \
554 'you have changed the set of files with translatable diagnostics;\n\
555 apply the above patch\n'
557 # Verify that all source files using _() are listed in po/POTFILES.in.
558 po_file
= po
/POTFILES.in
560 @if
test -f
$(po_file
); then \
561 grep
-E
-v
'^(#|$$)' $(po_file
) \
562 | grep
-v
'^src/false\.c$$' |
sort > $@
-1; \
564 for file in
$$($(VC_LIST_EXCEPT
)) lib
/*.
[ch
]; do \
565 test -r
$$file || continue
; \
567 *.m4|
*.mk
) continue
;; \
573 base
=`expr " $$file" : ' \(.*\)\..'`; \
574 { test -f
$$base.l ||
test -f
$$base.y
; } && continue
;; \
576 files
="$$files $$file"; \
578 grep
-E
-l
'\b(N?_|gettext *)\([^)"]*("|$$)' $$files \
580 diff
-u
-L
$(po_file
) -L
$(po_file
) $@
-1 $@
-2 \
581 ||
{ printf
'$(ME): '$(fix_po_file_diag
) 1>&2; exit
1; }; \
585 # Sometimes it is useful to change the PATH environment variable
586 # in Makefiles. When doing so, it's better not to use the Unix-centric
587 # path separator of `:', but rather the automake-provided `$(PATH_SEPARATOR)'.
588 msg
= '$(ME): Do not use `:'\'' above; use $$(PATH_SEPARATOR) instead'
589 sc_makefile_path_separator_check
:
590 @grep
-nE
'PATH[=].*:' \
591 $$($(VC_LIST_EXCEPT
) | grep
-E
'akefile|\.mk$$') \
592 && { echo
$(msg
) 1>&2; exit
1; } ||
:
594 # Check that `make alpha' will not fail at the end of the process.
596 if
test -d
$(release_archive_dir
); then
:; else \
597 for file in
$(distdir
).
tar.gz \
598 $(release_archive_dir
)/$(distdir
).
tar.gz
; do \
599 test -e
$$file || continue
; \
601 ||
{ echo ERROR
: $$file is not writable
; fail
=1; }; \
603 test "$$fail" && exit
1 ||
: ; \
606 v_etc_file
= lib
/version-etc.c
607 sample-test
= tests
/sample-test
608 texi
= doc
/$(PACKAGE
).texi
609 # Make sure that the copyright date in $(v_etc_file) is up to date.
610 # Do the same for the $(sample-test) and the main doc/.texi file.
612 @if
test -f
$(v_etc_file
); then \
613 grep
'enum { COPYRIGHT_YEAR = '$$(date
+%Y
)' };' $(v_etc_file
) \
615 ||
{ echo
'out of date copyright in $(v_etc_file); update it' 1>&2; \
618 @if
test -f
$(sample-test
); then \
619 grep
'# Copyright (C) '$$(date
+%Y
)' Free' $(sample-test
) \
621 ||
{ echo
'out of date copyright in $(sample-test); update it' 1>&2; \
624 @if
test -f
$(texi
); then \
625 grep
'Copyright @copyright{} .*'$$(date
+%Y
)' Free' $(texi
) \
627 ||
{ echo
'out of date copyright in $(texi); update it' 1>&2; \
632 (unset CDPATH
; cd
$(srcdir) && $(VC
) diff
) > vc-diffs ||
:
633 if
test -s vc-diffs
; then \
635 echo
"Some files are locally modified:" 1>&2; \
641 # Use this to make sure we don't run these programs when building
642 # from a virgin tgz file, below.
643 null_AM_MAKEFLAGS
= \
650 built_programs
= $$(cd src
&& MAKEFLAGS
= $(MAKE
) -s built_programs.list
)
652 rel-files
= $(DIST_ARCHIVES
)
654 gnulib_dir ?
= $(srcdir)/gnulib
655 gnulib-version
= $$(cd
$(gnulib_dir
) && git describe
)
656 bootstrap-tools ?
= autoconf
,automake
,gnulib
658 announcement
: NEWS ChangeLog
$(rel-files
)
659 @
$(build_aux
)/announce-gen \
660 --release-type
=$(RELEASE_TYPE
) \
661 --package
=$(PACKAGE
) \
662 --prev
=$(PREV_VERSION
) \
664 --gpg-key-id
=$(gpg_key_ID
) \
666 --bootstrap-tools
=$(bootstrap-tools
) \
667 --gnulib-version
=$(gnulib-version
) \
668 --no-print-checksums \
669 $(addprefix --url-dir
=, $(url_dir_list
))
671 ## ---------------- ##
672 ## Updating files. ##
673 ## ---------------- ##
675 ftp-gnu
= ftp
://ftp.gnu.org
/gnu
676 www-gnu
= http
://www.gnu.org
678 emit_upload_commands
:
679 @echo
=====================================
680 @echo
=====================================
681 @echo
"$(build_aux)/gnupload $(GNUPLOADFLAGS) \\"
682 @echo
" --to $(gnu_rel_host):$(PACKAGE) \\"
683 @echo
" $(rel-files)"
684 @echo
'# send the /tmp/announcement e-mail'
685 @echo
=====================================
686 @echo
=====================================
688 noteworthy
= * Noteworthy changes in release ?.?
(????
-??
-??
) [?
]
689 define emit-commit-log
690 printf
'%s\n' 'post-release administrivia' '' \
691 '* NEWS: Add header line for next release.' \
692 '* .prev-version: Record previous version.' \
693 '* cfg.mk (old_NEWS_hash): Auto-update.'
696 .PHONY
: no-submodule-changes
697 no-submodule-changes
:
698 if
test -d
$(srcdir)/.git
; then \
699 diff
=$$(cd
$(srcdir) && git submodule
-q
foreach \
700 git diff-index
--name-only HEAD
) \
702 case
$$diff in
'') ;; \
703 *) echo
'$(ME): submodule files are locally modified:'; \
704 echo
"$$diff"; exit
1;; esac
; \
709 .PHONY
: alpha beta stable
710 ALL_RECURSIVE_TARGETS
+= alpha beta stable
711 alpha beta stable
: $(local-check
) writable-files no-submodule-changes
713 && { echo
$(VERSION
) | grep
-E
'^[0-9]+(\.[0-9]+)+$$' \
714 ||
{ echo
"invalid version string: $(VERSION)" 1>&2; exit
1;};}\
716 $(MAKE
) vc-diff-check
717 $(MAKE
) news-date-check
719 $(MAKE
) dist XZ_OPT
=-9ev
720 $(MAKE
) -s announcement RELEASE_TYPE
=$@
> /tmp
/announce-
$(my_distdir
)
721 if
test -d
$(release_archive_dir
); then \
722 ln
$(rel-files
) $(release_archive_dir
); \
723 chmod a-w
$(rel-files
); \
725 $(MAKE
) -s emit_upload_commands RELEASE_TYPE
=$@
726 echo
$(VERSION
) > $(prev_version_file
)
727 $(MAKE
) update-NEWS-hash
728 perl
-pi
-e
'$$. == 3 and print "$(noteworthy)\n\n\n"' NEWS
729 $(emit-commit-log
) > .ci-msg
730 $(VC
) commit
-F .ci-msg
-a
734 @
test -z
"$(manual_title)" \
735 && { echo
define manual_title in cfg.mk
1>&2; exit
1; } ||
:
736 @cd
'$(srcdir)/doc'; \
737 $(SHELL
) ..
/build-aux
/gendocs.sh
-o
'$(abs_builddir)/doc/manual' \
738 --email
$(PACKAGE_BUGREPORT
) $(PACKAGE
) \
739 "$(PACKAGE_NAME) - $(manual_title)"
740 @echo
" *** Upload the doc/manual directory to web-cvs."
745 $(MAKE
) $(AM_MAKEFLAGS
) clean
746 lcov
--directory .
--zerocounters
748 COVERAGE_CCOPTS ?
= "-g --coverage"
749 COVERAGE_OUT ?
= doc
/coverage
752 $(MAKE
) $(AM_MAKEFLAGS
) CFLAGS
=$(COVERAGE_CCOPTS
) CXXFLAGS
=$(COVERAGE_CCOPTS
)
753 $(MAKE
) $(AM_MAKEFLAGS
) CFLAGS
=$(COVERAGE_CCOPTS
) CXXFLAGS
=$(COVERAGE_CCOPTS
) check
754 mkdir
-p
$(COVERAGE_OUT
)
755 lcov
--directory .
--output-file
$(COVERAGE_OUT
)/$(PACKAGE
).
info \
759 genhtml
--output-directory
$(COVERAGE_OUT
) \
760 $(COVERAGE_OUT
)/$(PACKAGE
).
info \
761 --highlight
--frames
--legend \
762 --title
"$(PACKAGE_NAME)"
764 coverage
: init-coverage build-coverage gen-coverage
766 # Update gettext files.
767 PACKAGE ?
= $(shell basename $(PWD
))
768 PO_DOMAIN ?
= $(PACKAGE
)
769 POURL
= http
://translationproject.org
/latest
/$(PO_DOMAIN
)/
772 rm -f
$(PODIR
)/*.po
&& \
773 echo
"$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
774 wget
--no-verbose
--directory-prefix
$(PODIR
) --no-directories
--recursive
--level
1 --accept .po
--accept .po
.1 $(POURL
) && \
775 echo
'en@boldquot' > $(PODIR
)/LINGUAS
&& \
776 echo
'en@quot' >> $(PODIR
)/LINGUAS
&& \
777 ls
$(PODIR
)/*.po | sed
's/\.po//' | sed
's,$(PODIR)/,,' |
sort >> $(PODIR
)/LINGUAS
779 INDENT_SOURCES ?
= $(C_SOURCES
)
782 indent
$(INDENT_SOURCES
)
784 # If you want to set UPDATE_COPYRIGHT_* environment variables,
785 # put the assignments in this variable.
786 update-copyright-env ?
=
788 # Run this rule once per year (usually early in January)
789 # to update all FSF copyright year lists in your project.
790 # If you have an additional project-specific rule,
791 # add it in cfg.mk along with a line 'update-copyright: prereq'.
792 # By default, exclude all variants of COPYING; you can also
793 # add exemptions (such as ChangeLog..* for rotated change logs)
794 # in the file .x-update-copyright.
795 .PHONY
: update-copyright
797 grep
-l
-w Copyright \
798 $$(export VC_LIST_EXCEPT_DEFAULT
=COPYING
&& $(VC_LIST_EXCEPT
)) \
799 |
$(update-copyright-env
) xargs
$(build_aux
)/$@